<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_product_typeHtmltype extends JPlugin
{
	function plgJoomsuite_product_typeHtmltype( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'htmltype') return;
		global $mainframe;
		$value = isset($obj->htmltype) ? $obj->htmltype : '';

		if (!strlen($value))	$value = $params->get('default_value', "");

		$width = $params->get('width', '100%');
		$height = $params->get('height', '300');

		$editor =& JFactory::getEditor($params->get('editor'));
		if( $params->get('short') && !$mainframe->isAdmin() ) {
			$editorParams = array( 'theme' => 'simple' );
			if ($params->get('editor') == 'tinymce')
			$editorParams['mode'] = 'simple';

			echo $editor->display("pparams[{$obj->id}][html]",
			htmlspecialchars(stripslashes($value), ENT_QUOTES, 'UTF-8'), $width, $height, '60', '20', false, $editorParams ) ;
		} else {
			echo $editor->display("pparams[{$obj->id}][html]",
			htmlspecialchars(stripslashes($value), ENT_QUOTES, 'UTF-8'), $width, $height, '60', '20', true ) ;
		}
	}

	function onBeforeSave(&$value, &$params, $type, $field_id, $row, &$error)
	{
		if($type != 'htmltype') return;

	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;
		if($type != 'htmltype') return;
		if(!$field) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;

		$fval = array('htmltype', substr($field->value, 5));
		if(!isset($fval[1]) || $fval[1] == '') return;

		$db = & JFactory::getDBO();
		$uri = JFactory::getURI();
		$me = JFactory::getUser();
		$out = '';

		$read = false;
		$buyer = false;
		if($me->id)
		{
			$sql = "SELECT COUNT(*) FROM #__jc_orders ord
			JOIN #__jc_orders_products pr ON ord.id = pr.order_id
			WHERE product_id = '{$field->record_id}' AND ord.user_id = '{$me->id}'
			AND pr.status_id = (SELECT id FROM #__jc_orders_statuses WHERE isfinal = '1' AND published = '1' AND  type= 'product')";
			$db->setQuery($sql);
			if($res = $db->loadResult())
			$buyer = $me->id;
		}
		else
		{
			$sql = "SELECT ord. email FROM #__jc_orders ord
			JOIN #__jc_orders_products pr ON ord.id = pr.order_id
			WHERE product_id = '{$field->record_id}' AND ord.user_id = 0
			AND pr.status_id = (SELECT id FROM #__jc_orders_statuses WHERE isfinal = '1' AND published = '1' AND  type= 'product')";
			$db->setQuery($sql);
			if($order_emails = $db->loadResultArray())
			{
				$session = JFactory::getSession();
				if($customer = $session->get('customer'))
				{
					if(in_array($customer['cemail'], $order_emails))
					{
						$buyer = $customer['cemail'];
					}
				}
			}
		}

		if($buyer) $read = true;

		if($read)
		{
			$sql = "SELECT ex.value, ex.ref_id, ex.record_id, ex.user_id, ex.field_id
			FROM #__jc_orders_products pr
			JOIN #__jc_orders ord ON pr.order_id = ord.id
			JOIN #__jc_orders_statuses os ON os.id = pr.status_id
			JOIN #__js_res_field_extra ex ON pr.product_id=ex.record_id
			WHERE ex.field_id = '{$field->field_id}'
			AND ex.record_id = '".(JRequest::getInt('download') && JRequest::getInt('record_id') ? JRequest::getInt('record_id') : $field->record_id)."'
			AND ord.user_id = '".$me->id."' AND os.isfinal = '1'";
			$db->setQuery($sql);
			if($res = $db->loadObject())
			{
				$value = stripslashes($fval[1]);

				if (function_exists('wordSensor'))
				wordSensor($value);

				$pattern = '#<hr\s+id=("|\')system-readmore("|\')\s*\/*>#i';
				$tagPos = preg_match($pattern, $value);

				if(!$tagPos) {
					$out = $value;
				} else 	{
					list($introtext, $fulltext) = preg_split($pattern, $value, 2);

					if(JRequest::getWord('view') == 'article')
					{
						// Cut out the intro text
						if ($params->get('hide_intro'))
						$out = $fulltext;
						else
						$out  =  $introtext . $fulltext;
					}
					else
					{
						$out =  $introtext;
					}
				}

				if (JRequest::getCmd('view') != 'article') {
					require_once JPATH_PLUGINS.DS.'joomsuite_product_type'.DS.'html'.DS.'html_stripper.php';

					$readMoreText = $params->get('seemore');

					// We the text does not contain a link
					if (!preg_match('/href=[\"\'](.*)[\"\']/', $readMoreText))
					{
						$articleLink = 'index.php?option=com_resource&controller=article&view=article&article='.$field->record_id.'&category_id='.JRequest::getInt('category_id').'&Itemid='.JRequest::getInt('Itemid');
						$clientId = JRequest::getInt('client_id');
						if ($clientId) {
							$articleLink .= '&client='.$clientId.'&client='.urlencode(JRequest::getString('client', '', 'default', JREQUEST_ALLOWRAW));
						}
						if ($readMoreText)
						{
							$readMoreText = JHTML::link($articleLink, $readMoreText, array('class' => 'readon'));
						}
					}

					$out = JSTypeHTMLStripper::substr($out, $params->get('length', 0), $readMoreText);
				}

				$regex = "/<pre>[^{]*{([a-zA-Z0-9\-_\|]*)}([^<]*)<\/pre>/iU";
				preg_match($regex, $out, $match);
				if(is_array($match))
				{
					$out = preg_replace_callback($regex, 'jsGeshiHighlite', $out);
				}

				$regex = "/<pre lang=\"([a-zA-Z0-9\-_\|]*)\">([^<]*)<\/pre>/iU";
				preg_match($regex, $out, $match);
				if(is_array($match))
				{
					$out = preg_replace_callback($regex, 'jsGeshiHighlite', $out);
				}

				$row->text = $out;
				$row->title = $field->title;
				$art_id = JRequest::getInt("article");
				$sql = "SELECT title FROM #__js_res_record WHERE id='$art_id'";
				$db->setQuery($sql);
				$row->title = $db->loadResult($sql);

				$dispatcher =& JDispatcher::getInstance();
				$plugins = $params->get('plugins', 'pagebreak');
				if($plugins)
				{
					settype($plugins, 'array');
					foreach($plugins as $plugin)
					{
						JPluginHelper::importPlugin('content',$plugin);
					}
					$dispatcher->trigger('onPrepareContent', array (& $row, $params, JRequest::getInt('limitstart',0)));
					$toc = (isset($row->toc))? $row->toc : '';
					$out = '<div class="article-content">'.$toc.$row->text.'</div>';
				}
			}
			else
			$out = JText::_("To see this field content you need to purchase this product");
		}
		else
		{
			$out = JText::_("To see this field content you need to purchase this product");
		}

	}

	function onOrderHistoryPrint($type, $order_id, $product_id, $value, $final_status, $user_id, $params)
	{
		if($type != 'htmltype') return;
		if($value == '') return;
		$out = '';
		$params = new JParameter($params);

		$db = & JFactory::getDBO();
		$out = '';

		$val = array('htmltype', substr($value, 5));

		if(isset($val[1]) && $val[1] != '')
		{
			$me = JFactory::getUser();

			$read = false;
			$buyer = false;
			if($me->id)
			{
				if($final_status)
				$buyer = $me->id;
			}
			else
			{
				$sql = "SELECT ord. email FROM #__jc_orders ord
				JOIN #__jc_orders_products pr ON ord.id = pr.order_id
				WHERE product_id = '{$product_id}' AND ord.user_id = 0
				AND pr.status_id = (SELECT id FROM #__jc_orders_statuses WHERE isfinal = '1' AND published = '1' AND  type= 'product')";
				$db->setQuery($sql);
				if($order_emails = $db->loadResultArray())
				{
					$session = JFactory::getSession();
					if($customer = $session->get('customer'))
					{
						if(in_array($customer['cemail'], $order_emails))
						{
							$buyer = $customer['cemail'];
						}
					}
				}
			}

			if($buyer)
			{
				$read = true;
			}


			if($read)
			{
				$value = stripslashes($val[1]);

				require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
				ResControllerConfig::initialyze();
				if (function_exists('wordSensor'))
				wordSensor($value);

				$pattern = '#<hr\s+id=("|\')system-readmore("|\')\s*\/*>#i';
				$tagPos = preg_match($pattern, $value);

				if(!$tagPos) {
					$out = $value;
				} else 	{
					list($introtext, $fulltext) = preg_split($pattern, $value, 2);

					if(JRequest::getWord('view') == 'article')
					{
						// Cut out the intro text
						if ($params->get('hide_intro'))
						$out = $fulltext;
						else
						$out  =  $introtext . $fulltext;
					}
					else
					{
						$out =  $introtext;
					}
				}

				if (JRequest::getCmd('view') != 'article') {
					require_once JPATH_PLUGINS.DS.'joomsuite_product_type'.DS.'html'.DS.'html_stripper.php';

					$readMoreText = $params->get('seemore');

					// We the text does not contain a link
					if (!preg_match('/href=[\"\'](.*)[\"\']/', $readMoreText))
					{
						$sql = "SELECT product_link FROM #__jc_orders_products WHERE product_id = '$product_id' AND order_id = '$order_id' LIMIT 1";
						$db->setQuery($sql);
						$articleLink = $db->loadResult();

						if ($readMoreText)
						{
							$readMoreText = JHTML::link($articleLink, $readMoreText, array('class' => 'readon', 'target' => '_blank'));
						}
					}

					$out = JSTypeHTMLStripper::substr($out, $params->get('length', 0), $readMoreText);
				}

				$regex = "/<pre>[^{]*{([a-zA-Z0-9\-_\|]*)}([^<]*)<\/pre>/iU";
				preg_match($regex, $out, $match);
				if(is_array($match))
				{
					$out = preg_replace_callback($regex, 'jsGeshiHighlite', $out);
				}

				$regex = "/<pre lang=\"([a-zA-Z0-9\-_\|]*)\">([^<]*)<\/pre>/iU";
				preg_match($regex, $out, $match);
				if(is_array($match))
				{
					$out = preg_replace_callback($regex, 'jsGeshiHighlite', $out);
				}

				$row->text = $out;
				$sql = "SELECT title FROM #__js_res_record WHERE id='$product_id'";
				$db->setQuery($sql);
				$row->title = $db->loadResult($sql);

				$dispatcher =& JDispatcher::getInstance();
				$plugins = $params->get('plugins', 'pagebreak');
				if($plugins)
				{
					JRequest::setVar('view', 'article');
					settype($plugins, 'array');
					foreach($plugins as $plugin)
					{
						JPluginHelper::importPlugin('content',$plugin);
					}
					$dispatcher->trigger('onPrepareContent', array (& $row, $params, JRequest::getInt('limitstart',0)));
					$toc = (isset($row->toc))? $row->toc : '';
					$out = '<div class="article-content">'.$toc.$row->text.'</div>';
						
					JRequest::_cleanVar('view');
				}
			}
		}

		return $out;
	}

}
?>